<template>
  <div class="order-correction-resources">
    <div
      v-for="({ superclass }, index) in resources"
      :key="superclass"
      class="resource-item"
    >
      <template v-if="isReadonly">
        <OrderResourceSelect
          :value="currentResource(superclass)"
          :is-disabled="true"
          :order-uuid="order.uuid"
          :org-name="currentExecutor() && currentExecutor().title"
          :is-enabled-select="false"
          :show-clear="false"
          :resource-superclass="superclass || ''"
          theme="default"
        />
      </template>
      <template v-else>
        <ObDrop
          @drop="onDrop(index, $event)"
        >
          <ObDrag
            :transferData="{
            fromItemIndex: index,
          }"
          >
            <div
              class="order-correction-resource"
              :class="{
                '--is-static': isReadonly
              }"
            >
              <div class="top-panel">
                <ObSelect
                  :value="superclass"
                  label="Вид ресурса"
                  placeholder="Выберите из списка"
                  :items="resourceTypeList(superclass)"
                  :is-standart="true"
                  value-exp="superclass"
                  data-qa="correctionResourceType"
                  @selected="onChangeResourceType(index, $event)"
                />
                <button
                  v-if="!isReadonly"
                  class="remove-resource-button"
                  @click="onRemoveResource(index)"
                >
                  <i class="icon close" />
                </button>
              </div>
              <OrderResourceSelect
                v-if="superclass"
                :value="currentResource(superclass)"
                :order-uuid="order.uuid"
                :org-name="currentExecutor() && currentExecutor().title"
                :is-enabled-select="false"
                :action-icon="false"
                :resource-superclass="superclass"
                theme="default"
                :dropdown-method="resourceDropdownMethod"
                @input="onChangeResource(index, $event, superclass)"
              />
            </div>
          </ObDrag>
        </ObDrop>
      </template>
    </div>
    <template v-if="!isReadonly && !isResourceDisabled()">
      <button
        class="add-resource-button"
        @click="onAddResource"
      >
        <i class="icon plus" />
        <span>Добавить ресурс</span>
      </button>
    </template>
  </div>
</template>

<script>
import OrderResourceSelect from '@/components/Order/resourceSelectors/orderResourceSelect'
import cloneDeep from "clone-deep"
import ObDrag from "common-components/src/obComponents/obDrag"
import ObDrop from "common-components/src/obComponents/obDrop"
import ObSelect from "common-components/src/obComponents/obSelect"
import api from '@/api'

const RESOURCE_MODEL = {
  superclass: null
}

export default {
  name: 'OrderCorrectionResources',
  components: {
    ObDrag,
    ObDrop,
    OrderResourceSelect,
    ObSelect
  },
  props: {
    resources: {
      type: Array,
      default: () => []
    },
    order: {
      type: Object,
      default: () => {}
    },
    isReadonly: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    resourcesList () {
      return [
        {
          title: 'Водитель',
          superclass: 'driver'
        },
        {
          title: 'Тягач',
          superclass: 'tractor'
        },
        {
          title: 'Прицеп',
          superclass: 'trailer'
        },
        {
          title: 'Контейнеровоз',
          superclass: 'container_truck'
        },
        {
          title: 'Фургон',
          superclass: 'van'
        },
        {
          title: 'Полуприцеп',
          superclass: 'semitrailer'
        },
        {
          title: 'Джамбо',
          superclass: 'jumbo'
        },
        {
          title: 'Трал',
          superclass: 'trals'
        },
        {
          title: 'Длинномер',
          superclass: 'lst'
        },
      ]
    },
  },
  methods: {
    resourceTypeList (superclass) {
      return this.resourcesList.filter((required) => {
        return this.resources.every(item => item.superclass !== required.superclass || required.superclass === superclass)
      })
    },
    resourceDropdownMethod (superclass) {
      return {
        method: api.orderProcess.nonFinancialAdjustmentsDropdown2,
        arguments: {
          code: 'RESOURCES',
          orderKind: this.order.isSuborder ? 'SUBORDER' : 'ORDER',
          orderUuid: this.order.uuid,
          superclass
        }
      }
    },
    currentResource (type) {
      if (!this.resources?.length) return null

      return this.resources.find((item) => item.resourceSuperclass === type || item.superclass === type)
    },
    isResourceDisabled () {
      return this.resources?.length === this.resourcesList?.length
    },
    currentExecutor () {
      return this.order && this.order.executor || null
    },
    onChangeField (path, value) {
      this.$emit('change', { path, value })
    },
    onDrop (index, $event) {
      let result = cloneDeep(this.resources)
      const { fromItemIndex } = $event
      const itemToMove = result.splice(fromItemIndex, 1)[0]
      result.splice(index, 0, itemToMove)

      this.onChangeField('', result)
    },
    onAddResource () {
      let newResources = cloneDeep(this.resources)

      newResources.push({ ...RESOURCE_MODEL })
      this.onChangeField('', newResources)
    },
    onChangeResourceType (index, data) {
      this.onChangeResource(index, { superclass: data.superclass })
    },
    onChangeResource (index, data, superclass) {
      let newResources = cloneDeep(this.resources)

      if (data) {
        newResources[index] = data
      } else {
        newResources[index] = { superclass }
      }
      this.onChangeField('', newResources)
    },
    onRemoveResource (index) {
      let newResources = cloneDeep(this.resources)

      newResources.splice(index, 1)
      this.onChangeField('', newResources)
    }
  },
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.order-correction-resources {
  .resource-item {
    & + .resource-item {
      margin-top: 10px;
    }
  }
  .add-resource-button {
    display: flex;
    align-items: center;
    margin: 15px 0 30px 0;
    padding: 0;
    border: none;
    background-color: transparent;
    outline: none;
    cursor: pointer;
    @include font-mixin(14px, 16px, 400, $color-blue-navy-blue);
    &:hover {
      opacity: 0.8;
    }
    .icon {
      margin-right: 6px;
      font-size: 16px;
    }
  }

  &::v-deep {
    .ob-draggable {
      position: relative;
      .drag-wrap {
        position: absolute;
        left: 12px;
        top: 22px;
        .icon {
          font-size: 24px;
          &::before {
            color: $color-blue-navy-blue;
          }
        }
      }
      .drag-content {
        min-height: 208px;
      }
    }
  }
}

.order-correction-resource {
  padding: 20px 54px 20px 44px;
  box-shadow: 0 0 2px rgba(0, 75, 200, 0.15), 0 0 12px rgba(0, 75, 200, 0.04), 0 4px 10px rgba(0, 75, 200, 0.06);
  border-radius: 4px;
  min-height: 208px;
  &.--is-static {
    padding-left: 20px;
  }
  .top-panel {
    margin-bottom: 15px;
    .remove-resource-button {
      position: absolute;
      top: 20px;
      right: 20px;
      margin: 0;
      padding: 0;
      border: none;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      &:hover {
        opacity: 0.8;
      }
      .icon {
        font-size: 20px;
        color: $color-grey-label;
      }
    }
  }
}
</style>